%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Projected_point = Project_Point_Plane_3P(Point_location, Plane_location_1, Plane_location_2, Plane_location_3)

% Если входные параметры - номера узлов, то существование узлов должно проверяться вне данной функции до ее вызова
% Нахождение координат точек Plane_location_1, Plane_location_2 и Plane_location_3 не на одной прямой должно проверяться вне данной функции до ее вызова

global DB_NODES;
global AT_NODES;

if (size(Point_location,1) == 3)
	Point = Point_location;
else
    Point = DB_NODES{AT_NODES(Point_location)}.Location;
end

if (size(Plane_location_1,1) == 3)
	D1 = Plane_location_1;
else
    D1 = DB_NODES{AT_NODES(Plane_location_1)}.Location;
end

if (size(Plane_location_2,1) == 3)
	D2 = Plane_location_2;
else
    D2 = DB_NODES{AT_NODES(Plane_location_2)}.Location;
end

if (size(Plane_location_3,1) == 3)
	D3 = Plane_location_3;
else
    D3 = DB_NODES{AT_NODES(Plane_location_3)}.Location;
end

% Нахождение уравнения плоскости
Plane = zeros(4,1);

normal = cross(D2-D1, D3-D1);

Plane(1) = normal(1);
Plane(2) = normal(2);
Plane(3) = normal(3);
Plane(4) = - normal(1)*D1(1) - normal(2)*D1(2) - normal(3)*D1(3);

if (abs(Plane(4)) > 1)
    Plane = Plane / Plane(4);
end

% Проецирование точки на плоскость
Projected_point = zeros(3,1);

t = (-Plane(4) - Plane(1)*Point(1) - Plane(2)*Point(2) - Plane(3)*Point(3))/(Plane(1)*Plane(1) + Plane(2)*Plane(2) + Plane(3)*Plane(3));

Projected_point(1) = Point(1) + Plane(1)*t;
Projected_point(2) = Point(2) + Plane(2)*t;
Projected_point(3) = Point(3) + Plane(3)*t;
